git-stash.shon commit stash: simplify defaulting to "save" and reject unknown options (3c2eb80)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless [save [-k|--keep-index] [-q|--quiet] [<message>]]
  11   or: $dashless clear"
  12
  13SUBDIRECTORY_OK=Yes
  14OPTIONS_SPEC=
  15. git-sh-setup
  16require_work_tree
  17cd_to_toplevel
  18
  19TMP="$GIT_DIR/.git-stash.$$"
  20trap 'rm -f "$TMP-*"' 0
  21
  22ref_stash=refs/stash
  23
  24if git config --get-colorbool color.interactive; then
  25       help_color="$(git config --get-color color.interactive.help 'red bold')"
  26       reset_color="$(git config --get-color '' reset)"
  27else
  28       help_color=
  29       reset_color=
  30fi
  31
  32no_changes () {
  33        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  34        git diff-files --quiet --ignore-submodules
  35}
  36
  37clear_stash () {
  38        if test $# != 0
  39        then
  40                die "git stash clear with parameters is unimplemented"
  41        fi
  42        if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
  43        then
  44                git update-ref -d $ref_stash $current
  45        fi
  46}
  47
  48create_stash () {
  49        stash_msg="$1"
  50
  51        git update-index -q --refresh
  52        if no_changes
  53        then
  54                exit 0
  55        fi
  56
  57        # state of the base commit
  58        if b_commit=$(git rev-parse --verify HEAD)
  59        then
  60                head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
  61        else
  62                die "You do not have the initial commit yet"
  63        fi
  64
  65        if branch=$(git symbolic-ref -q HEAD)
  66        then
  67                branch=${branch#refs/heads/}
  68        else
  69                branch='(no branch)'
  70        fi
  71        msg=$(printf '%s: %s' "$branch" "$head")
  72
  73        # state of the index
  74        i_tree=$(git write-tree) &&
  75        i_commit=$(printf 'index on %s\n' "$msg" |
  76                git commit-tree $i_tree -p $b_commit) ||
  77                die "Cannot save the current index state"
  78
  79        if test -z "$patch_mode"
  80        then
  81
  82                # state of the working tree
  83                w_tree=$( (
  84                        rm -f "$TMP-index" &&
  85                        cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
  86                        GIT_INDEX_FILE="$TMP-index" &&
  87                        export GIT_INDEX_FILE &&
  88                        git read-tree -m $i_tree &&
  89                        git add -u &&
  90                        git write-tree &&
  91                        rm -f "$TMP-index"
  92                ) ) ||
  93                        die "Cannot save the current worktree state"
  94
  95        else
  96
  97                rm -f "$TMP-index" &&
  98                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
  99
 100                # find out what the user wants
 101                GIT_INDEX_FILE="$TMP-index" \
 102                        git add--interactive --patch=stash -- &&
 103
 104                # state of the working tree
 105                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 106                die "Cannot save the current worktree state"
 107
 108                git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
 109                test -s "$TMP-patch" ||
 110                die "No changes selected"
 111
 112                rm -f "$TMP-index" ||
 113                die "Cannot remove temporary index (can't happen)"
 114
 115        fi
 116
 117        # create the stash
 118        if test -z "$stash_msg"
 119        then
 120                stash_msg=$(printf 'WIP on %s' "$msg")
 121        else
 122                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 123        fi
 124        w_commit=$(printf '%s\n' "$stash_msg" |
 125                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
 126                die "Cannot record working tree state"
 127}
 128
 129save_stash () {
 130        keep_index=
 131        patch_mode=
 132        while test $# != 0
 133        do
 134                case "$1" in
 135                -k|--keep-index)
 136                        keep_index=t
 137                        ;;
 138                --no-keep-index)
 139                        keep_index=
 140                        ;;
 141                -p|--patch)
 142                        patch_mode=t
 143                        keep_index=t
 144                        ;;
 145                -q|--quiet)
 146                        GIT_QUIET=t
 147                        ;;
 148                --)
 149                        shift
 150                        break
 151                        ;;
 152                -*)
 153                        echo "error: unknown option for 'stash save': $1"
 154                        usage
 155                        ;;
 156                *)
 157                        break
 158                        ;;
 159                esac
 160                shift
 161        done
 162
 163        stash_msg="$*"
 164
 165        git update-index -q --refresh
 166        if no_changes
 167        then
 168                say 'No local changes to save'
 169                exit 0
 170        fi
 171        test -f "$GIT_DIR/logs/$ref_stash" ||
 172                clear_stash || die "Cannot initialize stash"
 173
 174        create_stash "$stash_msg"
 175
 176        # Make sure the reflog for stash is kept.
 177        : >>"$GIT_DIR/logs/$ref_stash"
 178
 179        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
 180                die "Cannot save the current status"
 181        say Saved working directory and index state "$stash_msg"
 182
 183        if test -z "$patch_mode"
 184        then
 185                git reset --hard ${GIT_QUIET:+-q}
 186
 187                if test -n "$keep_index" && test -n $i_tree
 188                then
 189                        git read-tree --reset -u $i_tree
 190                fi
 191        else
 192                git apply -R < "$TMP-patch" ||
 193                die "Cannot remove worktree changes"
 194
 195                if test -z "$keep_index"
 196                then
 197                        git reset
 198                fi
 199        fi
 200}
 201
 202have_stash () {
 203        git rev-parse --verify $ref_stash >/dev/null 2>&1
 204}
 205
 206list_stash () {
 207        have_stash || return 0
 208        git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
 209        sed -n -e 's/^[.0-9a-f]* refs\///p'
 210}
 211
 212show_stash () {
 213        flags=$(git rev-parse --no-revs --flags "$@")
 214        if test -z "$flags"
 215        then
 216                flags=--stat
 217        fi
 218
 219        w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
 220        b_commit=$(git rev-parse --verify "$w_commit^") &&
 221        git diff $flags $b_commit $w_commit
 222}
 223
 224apply_stash () {
 225        git update-index -q --refresh &&
 226        git diff-files --quiet --ignore-submodules ||
 227                die 'Cannot apply to a dirty working tree, please stage your changes'
 228
 229        unstash_index=
 230
 231        while test $# != 0
 232        do
 233                case "$1" in
 234                --index)
 235                        unstash_index=t
 236                        ;;
 237                -q|--quiet)
 238                        GIT_QUIET=t
 239                        ;;
 240                *)
 241                        break
 242                        ;;
 243                esac
 244                shift
 245        done
 246
 247        # current index state
 248        c_tree=$(git write-tree) ||
 249                die 'Cannot apply a stash in the middle of a merge'
 250
 251        # stash records the work tree, and is a merge between the
 252        # base commit (first parent) and the index tree (second parent).
 253        s=$(git rev-parse --verify --default $ref_stash "$@") &&
 254        w_tree=$(git rev-parse --verify "$s:") &&
 255        b_tree=$(git rev-parse --verify "$s^1:") &&
 256        i_tree=$(git rev-parse --verify "$s^2:") ||
 257                die "$*: no valid stashed state found"
 258
 259        unstashed_index_tree=
 260        if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
 261                        test "$c_tree" != "$i_tree"
 262        then
 263                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 264                test $? -ne 0 &&
 265                        die 'Conflicts in index. Try without --index.'
 266                unstashed_index_tree=$(git write-tree) ||
 267                        die 'Could not save index tree'
 268                git reset
 269        fi
 270
 271        eval "
 272                GITHEAD_$w_tree='Stashed changes' &&
 273                GITHEAD_$c_tree='Updated upstream' &&
 274                GITHEAD_$b_tree='Version stash was based on' &&
 275                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 276        "
 277
 278        if test -n "$GIT_QUIET"
 279        then
 280                export GIT_MERGE_VERBOSITY=0
 281        fi
 282        if git merge-recursive $b_tree -- $c_tree $w_tree
 283        then
 284                # No conflict
 285                if test -n "$unstashed_index_tree"
 286                then
 287                        git read-tree "$unstashed_index_tree"
 288                else
 289                        a="$TMP-added" &&
 290                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 291                        git read-tree --reset $c_tree &&
 292                        git update-index --add --stdin <"$a" ||
 293                                die "Cannot unstage modified files"
 294                        rm -f "$a"
 295                fi
 296                squelch=
 297                if test -n "$GIT_QUIET"
 298                then
 299                        squelch='>/dev/null 2>&1'
 300                fi
 301                eval "git status $squelch" || :
 302        else
 303                # Merge conflict; keep the exit status from merge-recursive
 304                status=$?
 305                if test -n "$unstash_index"
 306                then
 307                        echo >&2 'Index was not unstashed.'
 308                fi
 309                exit $status
 310        fi
 311}
 312
 313drop_stash () {
 314        have_stash || die 'No stash entries to drop'
 315
 316        while test $# != 0
 317        do
 318                case "$1" in
 319                -q|--quiet)
 320                        GIT_QUIET=t
 321                        ;;
 322                *)
 323                        break
 324                        ;;
 325                esac
 326                shift
 327        done
 328
 329        if test $# = 0
 330        then
 331                set x "$ref_stash@{0}"
 332                shift
 333        fi
 334        # Verify supplied argument looks like a stash entry
 335        s=$(git rev-parse --verify "$@") &&
 336        git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
 337        git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
 338        git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
 339                die "$*: not a valid stashed state"
 340
 341        git reflog delete --updateref --rewrite "$@" &&
 342                say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
 343
 344        # clear_stash if we just dropped the last stash entry
 345        git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
 346}
 347
 348apply_to_branch () {
 349        have_stash || die 'Nothing to apply'
 350
 351        test -n "$1" || die 'No branch name specified'
 352        branch=$1
 353
 354        if test -z "$2"
 355        then
 356                set x "$ref_stash@{0}"
 357        fi
 358        stash=$2
 359
 360        git checkout -b $branch $stash^ &&
 361        apply_stash --index $stash &&
 362        drop_stash $stash
 363}
 364
 365# The default command is "save" if nothing but options are given
 366seen_non_option=
 367for opt
 368do
 369        case "$opt" in
 370        -*) ;;
 371        *) seen_non_option=t; break ;;
 372        esac
 373done
 374
 375test -n "$seen_non_option" || set "save" "$@"
 376
 377# Main command set
 378case "$1" in
 379list)
 380        shift
 381        if test $# = 0
 382        then
 383                set x -n 10
 384                shift
 385        fi
 386        list_stash "$@"
 387        ;;
 388show)
 389        shift
 390        show_stash "$@"
 391        ;;
 392save)
 393        shift
 394        save_stash "$@"
 395        ;;
 396apply)
 397        shift
 398        apply_stash "$@"
 399        ;;
 400clear)
 401        shift
 402        clear_stash "$@"
 403        ;;
 404create)
 405        if test $# -gt 0 && test "$1" = create
 406        then
 407                shift
 408        fi
 409        create_stash "$*" && echo "$w_commit"
 410        ;;
 411drop)
 412        shift
 413        drop_stash "$@"
 414        ;;
 415pop)
 416        shift
 417        if apply_stash "$@"
 418        then
 419                test -z "$unstash_index" || shift
 420                drop_stash "$@"
 421        fi
 422        ;;
 423branch)
 424        shift
 425        apply_to_branch "$@"
 426        ;;
 427*)
 428        case $# in
 429        0)
 430                save_stash &&
 431                say '(To restore them type "git stash apply")'
 432                ;;
 433        *)
 434                usage
 435        esac
 436        ;;
 437esac